#!/bin/sh

set -eo pipefail
set -vx

bin_package="$1"
deb="$2"
package="$3"
old_version="$4"
source_repo="$5"
workdir="$6"

get_changelog() (
    mkdir -p "$workdir"
    cd "$workdir"
    rm -rf source-dir changelog

    dpkg-deb --fsys-tarfile "$deb" | tar xOf - ./usr/share/doc/"$bin_package"/changelog.gz ./usr/share/doc/"$bin_package"/changelog.Debian.gz >changelog || true
    if test -s changelog
    then
        mkdir -p source-dir/debian
        zcat changelog >source-dir/debian/changelog
    else
        dpkg-source --no-copy -x "$source_repo"/pool/*/*/"$package"/"$package"_*.dsc source-dir >log || {
            echo No source
            return
        }
    fi

    dpkg-parsechangelog --file source-dir/debian/changelog --since "$old_version" -S Changes | grep -v '^  \[' || true
)

get_changelog

